diff -ruN vdr-1.3.24/dvbplayer.c vdr-1.3.25/dvbplayer.c
--- vdr-1.3.24/dvbplayer.c	2005-05-08 16:52:49.000000000 +0200
+++ vdr-1.3.25/dvbplayer.c	2005-05-22 13:26:51.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 1.33 2005/05/08 14:52:49 kls Exp $
+ * $Id: dvbplayer.c 1.34 2005/05/22 11:26:51 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -355,7 +355,7 @@
      }
   else if (active) {
      running = false;
-     Cancel(3);
+     Cancel(9);
      active = false;
      }
 }
diff -ruN vdr-1.3.24/eit.c vdr-1.3.25/eit.c
--- vdr-1.3.24/eit.c	2005-03-20 13:33:51.000000000 +0100
+++ vdr-1.3.25/eit.c	2005-05-28 13:35:55.000000000 +0200
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 1.103 2005/03/20 12:33:51 kls Exp $
+ * $Id: eit.c 1.107 2005/05/28 11:35:55 kls Exp $
  */
 
 #include "eit.h"
@@ -48,12 +48,16 @@
 
   SI::EIT::Event SiEitEvent;
   for (SI::Loop::Iterator it; eventLoop.getNext(SiEitEvent, it); ) {
+      // Drop bogus events.
+      if (SiEitEvent.getStartTime() == 0 || SiEitEvent.getDuration() == 0)
+         continue;
       Empty = false;
+      cEvent *newEvent = NULL;
       cEvent *pEvent = (cEvent *)pSchedule->GetEvent(SiEitEvent.getEventId(), SiEitEvent.getStartTime());
       if (!pEvent) {
          // If we don't have that event yet, we create a new one.
          // Otherwise we copy the information into the existing event anyway, because the data might have changed.
-         pEvent = pSchedule->AddEvent(new cEvent(channelID, SiEitEvent.getEventId()));
+         pEvent = newEvent = new cEvent(SiEitEvent.getEventId());
          if (!pEvent)
             continue;
          }
@@ -91,8 +95,7 @@
       SI::ExtendedEventDescriptors *ExtendedEventDescriptors = NULL;
       SI::ShortEventDescriptor *ShortEventDescriptor = NULL;
       cLinkChannels *LinkChannels = NULL;
-      int NumComponents = 0;
-      SI::ComponentDescriptor *ComponentDescriptors[MAXCOMPONENTS];
+      cComponents *Components = NULL;
       for (SI::Loop::Iterator it2; (d = SiEitEvent.eventDescriptors.getNext(it2)); ) {
           switch (d->getDescriptorTag()) {
             case SI::ExtendedEventDescriptorTag: {
@@ -193,12 +196,10 @@
                  uchar Stream = cd->getStreamContent();
                  uchar Type = cd->getComponentType();
                  if (1 <= Stream && Stream <= 2 && Type != 0) {
-                    if (NumComponents < MAXCOMPONENTS) {
-                       ComponentDescriptors[NumComponents++] = cd;
-                       d = NULL; // so that it is not deleted
-                       }
-                    else
-                       dsyslog("more than %d component descriptors!", MAXCOMPONENTS);
+                    if (!Components)
+                       Components = new cComponents;
+                    char buffer[256];
+                    Components->SetComponent(Components->NumComponents(), cd->getStreamContent(), cd->getComponentType(), I18nNormalizeLanguageCode(cd->languageCode), cd->description.getText(buffer, sizeof(buffer)));
                     }
                  }
                  break;
@@ -221,18 +222,10 @@
       delete ExtendedEventDescriptors;
       delete ShortEventDescriptor;
 
-      if (NumComponents > 0) {
-         cComponents *Components = new cComponents(NumComponents);
-         for (int i = 0; i < NumComponents; i++) {
-             char buffer[256];
-             SI::ComponentDescriptor *cd = ComponentDescriptors[i];
-             Components->SetComponent(i, cd->getStreamContent(), cd->getComponentType(), I18nNormalizeLanguageCode(cd->languageCode), cd->description.getText(buffer, sizeof(buffer)));
-             delete cd;
-             }
-         pEvent->SetComponents(Components);
-         }
-      else
-         pEvent->SetComponents(NULL);
+      if (newEvent)
+         pSchedule->AddEvent(newEvent);
+
+      pEvent->SetComponents(Components);
 
       pEvent->FixEpgBugs();
       if (LinkChannels)
diff -ruN vdr-1.3.24/epg.c vdr-1.3.25/epg.c
--- vdr-1.3.24/epg.c	2005-05-05 15:53:19.000000000 +0200
+++ vdr-1.3.25/epg.c	2005-05-29 12:19:48.000000000 +0200
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 1.29 2005/05/05 13:53:19 kls Exp $
+ * $Id: epg.c 1.34 2005/05/29 10:19:48 kls Exp $
  */
 
 #include "epg.h"
@@ -40,11 +40,10 @@
 
 // --- cComponents -----------------------------------------------------------
 
-cComponents::cComponents(int NumComponents)
+cComponents::cComponents(void)
 {
-  numComponents = NumComponents;
-  components = MALLOC(tComponent, numComponents);
-  memset(components, 0, sizeof(tComponent) * numComponents);
+  numComponents = 0;
+  components = NULL;
 }
 
 cComponents::~cComponents(void)
@@ -54,31 +53,37 @@
   free(components);
 }
 
-bool cComponents::SetComponent(int Index, const char *s)
+void cComponents::Realloc(int Index)
 {
-  if (Index < numComponents)
-     return components[Index].FromString(s);
-  return false;
+  if (Index >= numComponents) {
+     int n = numComponents;
+     numComponents = Index + 1;
+     components = (tComponent *)realloc(components, numComponents * sizeof(tComponent));
+     memset(&components[n], 0, sizeof(tComponent) * (numComponents - n));
+     }
 }
 
-bool cComponents::SetComponent(int Index, uchar Stream, uchar Type, const char *Language, const char *Description)
+void cComponents::SetComponent(int Index, const char *s)
 {
-  if (Index < numComponents) {
-     tComponent *p = &components[Index];
-     p->stream = Stream;
-     p->type = Type;
-     strn0cpy(p->language, Language, sizeof(p->language));
-     p->description = strcpyrealloc(p->description, !isempty(Description) ? Description : NULL);
-     return true;
-     }
-  return false;
+  Realloc(Index);
+  components[Index].FromString(s);
+}
+
+void cComponents::SetComponent(int Index, uchar Stream, uchar Type, const char *Language, const char *Description)
+{
+  Realloc(Index);
+  tComponent *p = &components[Index];
+  p->stream = Stream;
+  p->type = Type;
+  strn0cpy(p->language, Language, sizeof(p->language));
+  p->description = strcpyrealloc(p->description, !isempty(Description) ? Description : NULL);
 }
 
 // --- cEvent ----------------------------------------------------------------
 
-cEvent::cEvent(tChannelID ChannelID, u_int16_t EventID)
+cEvent::cEvent(u_int16_t EventID)
 {
-  channelID = ChannelID;
+  schedule = NULL;
   eventID = EventID;
   tableID = 0;
   version = 0xFF; // actual version numbers are 0..31
@@ -107,9 +112,20 @@
   return startTime - e->startTime;
 }
 
+tChannelID cEvent::ChannelID(void) const
+{
+  return schedule ? schedule->ChannelID() : tChannelID();
+}
+
 void cEvent::SetEventID(u_int16_t EventID)
 {
-  eventID = EventID;
+  if (eventID != EventID) {
+     if (schedule)
+        schedule->UnhashEvent(this);
+     eventID = EventID;
+     if (schedule)
+        schedule->HashEvent(this);
+     }
 }
 
 void cEvent::SetTableID(uchar TableID)
@@ -153,7 +169,13 @@
 
 void cEvent::SetStartTime(time_t StartTime)
 {
-  startTime = StartTime;
+  if (startTime != StartTime) {
+     if (schedule)
+        schedule->UnhashEvent(this);
+     startTime = StartTime;
+     if (schedule)
+        schedule->HashEvent(this);
+     }
 }
 
 void cEvent::SetDuration(int Duration)
@@ -187,30 +209,17 @@
 
 cString cEvent::GetDateString(void) const
 {
-  char buf[32];
-  struct tm tm_r;
-  tm *tm = localtime_r(&startTime, &tm_r);
-  char *p = stpcpy(buf, WeekDayName(tm->tm_wday));
-  *p++ = ' ';
-  strftime(p, sizeof(buf) - (p - buf), "%d.%m.%Y", tm);
-  return buf;
+  return DateString(startTime);
 }
 
 cString cEvent::GetTimeString(void) const
 {
-  char buf[25];
-  struct tm tm_r;
-  strftime(buf, sizeof(buf), "%R", localtime_r(&startTime, &tm_r));
-  return buf;
+  return TimeString(startTime);
 }
 
 cString cEvent::GetEndTimeString(void) const
 {
-  char buf[25];
-  time_t EndTime = startTime + duration;
-  struct tm tm_r;
-  strftime(buf, sizeof(buf), "%R", localtime_r(&EndTime, &tm_r));
-  return buf;
+  return TimeString(startTime + duration);
 }
 
 cString cEvent::GetVpsString(void) const
@@ -221,10 +230,11 @@
   return buf;
 }
 
-void cEvent::Dump(FILE *f, const char *Prefix) const
+void cEvent::Dump(FILE *f, const char *Prefix, bool InfoOnly) const
 {
-  if (startTime + duration + Setup.EPGLinger * 60 >= time(NULL)) {
-     fprintf(f, "%sE %u %ld %d %X\n", Prefix, eventID, startTime, duration, tableID);
+  if (InfoOnly || startTime + duration + Setup.EPGLinger * 60 >= time(NULL)) {
+     if (!InfoOnly)
+        fprintf(f, "%sE %u %ld %d %X\n", Prefix, eventID, startTime, duration, tableID);
      if (!isempty(title))
         fprintf(f, "%sT %s\n", Prefix, title);
      if (!isempty(shortText))
@@ -240,18 +250,40 @@
             fprintf(f, "%sX %s\n", Prefix, *p->ToString());
             }
         }
-     if (vps)
+     if (!InfoOnly && vps)
         fprintf(f, "%sV %ld\n", Prefix, vps);
-     fprintf(f, "%se\n", Prefix);
+     if (!InfoOnly)
+        fprintf(f, "%se\n", Prefix);
      }
 }
 
+bool cEvent::Parse(char *s)
+{
+  char *t = skipspace(s + 1);
+  switch (*s) {
+    case 'T': SetTitle(t);
+              break;
+    case 'S': SetShortText(t);
+              break;
+    case 'D': strreplace(t, '|', '\n');
+              SetDescription(t);
+              break;
+    case 'X': if (!components)
+                 components = new cComponents;
+              components->SetComponent(components->NumComponents(), t);
+              break;
+    case 'V': SetVps(atoi(t));
+              break;
+    default:  esyslog("ERROR: unexpected tag while reading EPG data: %s", s);
+              return false;
+    }
+  return true;
+}
+
 bool cEvent::Read(FILE *f, cSchedule *Schedule)
 {
   if (Schedule) {
      cEvent *Event = NULL;
-     int NumComponents = 0;
-     char *ComponentStrings[MAXCOMPONENTS];
      char *s;
      cReadLine ReadLine;
      while ((s = ReadLine.Read(f)) != NULL) {
@@ -265,53 +297,25 @@
                           int n = sscanf(t, "%u %ld %d %X", &EventID, &StartTime, &Duration, &TableID);
                           if (n == 3 || n == 4) {
                              Event = (cEvent *)Schedule->GetEvent(EventID, StartTime);
+                             cEvent *newEvent = NULL;
                              if (!Event)
-                                Event = Schedule->AddEvent(new cEvent(Schedule->ChannelID(), EventID));
+                                Event = newEvent = new cEvent(EventID);
                              if (Event) {
                                 Event->SetTableID(TableID);
                                 Event->SetStartTime(StartTime);
                                 Event->SetDuration(Duration);
+                                if (newEvent)
+                                   Schedule->AddEvent(newEvent);
                                 }
                              }
-                          NumComponents = 0;
-                          }
-                       break;
-             case 'T': if (Event)
-                          Event->SetTitle(t);
-                       break;
-             case 'S': if (Event)
-                          Event->SetShortText(t);
-                       break;
-             case 'D': if (Event) {
-                          strreplace(t, '|', '\n');
-                          Event->SetDescription(t);
-                          }
-                       break;
-             case 'X': if (Event) {
-                          if (NumComponents < MAXCOMPONENTS)
-                             ComponentStrings[NumComponents++] = strdup(t);
-                          else
-                             dsyslog("more than %d component descriptors!", MAXCOMPONENTS);
                           }
                        break;
-             case 'V': if (Event)
-                          Event->SetVps(atoi(t));
-                       break;
-             case 'e': if (Event && NumComponents > 0) {
-                          cComponents *Components = new cComponents(NumComponents);
-                          for (int i = 0; i < NumComponents; i++) {
-                              if (!Components->SetComponent(i, ComponentStrings[i]))
-                                 esyslog("ERROR: faulty component string in EPG data: '%s'", ComponentStrings[i]);
-                              free(ComponentStrings[i]);
-                              }
-                          Event->SetComponents(Components);
-                          }
-                       Event = NULL;
+             case 'e': Event = NULL;
                        break;
              case 'c': // to keep things simple we react on 'c' here
                        return true;
-             default:  esyslog("ERROR: unexpected tag while reading EPG data: %s", s);
-                       return false;
+             default:  if (Event && !Event->Parse(s))
+                          return false;
              }
            }
      esyslog("ERROR: unexpected end of file while reading EPG data");
@@ -649,9 +653,34 @@
 cEvent *cSchedule::AddEvent(cEvent *Event)
 {
   events.Add(Event);
+  Event->schedule = this;
+  HashEvent(Event);
   return Event;
 }
 
+void cSchedule::DelEvent(cEvent *Event)
+{
+  if (Event->schedule == this) {
+     UnhashEvent(Event);
+     events.Del(Event);
+     Event->schedule = NULL;
+     }
+}
+
+void cSchedule::HashEvent(cEvent *Event)
+{
+  eventsHashID.Add(Event, Event->EventID());
+  if (Event->StartTime() > 0) // 'StartTime < 0' is apparently used with NVOD channels
+     eventsHashStartTime.Add(Event, Event->StartTime());
+}
+
+void cSchedule::UnhashEvent(cEvent *Event)
+{
+  eventsHashID.Del(Event, Event->EventID());
+  if (Event->StartTime() > 0) // 'StartTime < 0' is apparently used with NVOD channels
+     eventsHashStartTime.Del(Event, Event->StartTime());
+}
+
 const cEvent *cSchedule::GetPresentEvent(bool CheckRunningStatus) const
 {
   const cEvent *pe = NULL;
@@ -680,13 +709,9 @@
 {
   // Returns either the event info with the given EventID or, if that one can't
   // be found, the one with the given StartTime (or NULL if neither can be found)
-  cEvent *pt = NULL;
-  for (cEvent *pe = events.First(); pe; pe = events.Next(pe)) {
-      if (pe->EventID() == EventID)
-         return pe;
-      if (StartTime > 0 && pe->StartTime() == StartTime) // 'StartTime < 0' is apparently used with NVOD channels
-         pt = pe;
-      }
+  cEvent *pt = eventsHashID.Get(EventID);
+  if (!pt && StartTime > 0) // 'StartTime < 0' is apparently used with NVOD channels
+     pt = eventsHashStartTime.Get(StartTime);
   return pt;
 }
 
@@ -753,7 +778,7 @@
       if (!Event)
          break;
       if (!Event->HasTimer() && Event->EndTime() + Setup.EPGLinger * 60 + 3600 < Time) { // adding one hour for safety
-         events.Del(Event);
+         DelEvent(Event);
          a--;
          }
       }
diff -ruN vdr-1.3.24/epg.h vdr-1.3.25/epg.h
--- vdr-1.3.24/epg.h	2005-03-20 13:32:36.000000000 +0100
+++ vdr-1.3.25/epg.h	2005-05-28 13:32:36.000000000 +0200
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.h 1.21 2005/03/20 12:32:36 kls Exp $
+ * $Id: epg.h 1.25 2005/05/28 11:32:36 kls Exp $
  */
 
 #ifndef __EPG_H
@@ -18,7 +18,6 @@
 #include "tools.h"
 
 #define MAXEPGBUGFIXLEVEL 3
-#define MAXCOMPONENTS 32
 
 enum eDumpMode { dmAll, dmPresent, dmFollowing, dmAtTime };
 
@@ -35,20 +34,22 @@
 private:
   int numComponents;
   tComponent *components;
+  void Realloc(int Index);
 public:
-  cComponents(int NumComponents);
+  cComponents(void);
   ~cComponents(void);
   int NumComponents(void) const { return numComponents; }
-  bool SetComponent(int Index, const char *s);
-  bool SetComponent(int Index, uchar Stream, uchar Type, const char *Language, const char *Description);
+  void SetComponent(int Index, const char *s);
+  void SetComponent(int Index, uchar Stream, uchar Type, const char *Language, const char *Description);
   tComponent *Component(int Index) const { return (Index < numComponents) ? &components[Index] : NULL; }
   };
 
 class cSchedule;
 
 class cEvent : public cListObject {
+  friend class cSchedule;
 private:
-  tChannelID channelID;    // Channel ID of program for this event
+  cSchedule *schedule;     // The Schedule this event belongs to
   u_int16_t eventID;       // Event ID of this event
   uchar tableID;           // Table ID this event came from
   uchar version;           // Version number of section this event came from
@@ -56,16 +57,16 @@
   char *title;             // Title of this event
   char *shortText;         // Short description of this event (typically the episode name in case of a series)
   char *description;       // Description of this event
-  cComponents *components; // The stream components of this event (separated by '\n')
+  cComponents *components; // The stream components of this event
   time_t startTime;        // Start time of this event
   int duration;            // Duration of this event in seconds
   time_t vps;              // Video Programming Service timestamp (VPS, aka "Programme Identification Label", PIL)
   time_t seen;             // When this event was last seen in the data stream
 public:
-  cEvent(tChannelID ChannelID, u_int16_t EventID);
+  cEvent(u_int16_t EventID);
   ~cEvent();
   virtual int Compare(const cListObject &ListObject) const;
-  tChannelID ChannelID(void) const { return channelID; }
+  tChannelID ChannelID(void) const;
   u_int16_t EventID(void) const { return eventID; }
   uchar TableID(void) const { return tableID; }
   uchar Version(void) const { return version; }
@@ -98,7 +99,8 @@
   void SetDuration(int Duration);
   void SetVps(time_t Vps);
   void SetSeen(void);
-  void Dump(FILE *f, const char *Prefix = "") const;
+  void Dump(FILE *f, const char *Prefix = "", bool InfoOnly = false) const;
+  bool Parse(char *s);
   static bool Read(FILE *f, cSchedule *Schedule);
   void FixEpgBugs(void);
   };
@@ -109,6 +111,8 @@
 private:
   tChannelID channelID;
   cList<cEvent> events;
+  cHash<cEvent> eventsHashID;
+  cHash<cEvent> eventsHashStartTime;
   bool hasRunning;
   time_t modified;
   time_t presentSeen;
@@ -127,6 +131,9 @@
   void Cleanup(time_t Time);
   void Cleanup(void);
   cEvent *AddEvent(cEvent *Event);
+  void DelEvent(cEvent *Event);
+  void cSchedule::HashEvent(cEvent *Event);
+  void cSchedule::UnhashEvent(cEvent *Event);
   const cList<cEvent> *Events(void) const { return &events; }
   const cEvent *GetPresentEvent(bool CheckRunningStatus = false) const;
   const cEvent *GetFollowingEvent(bool CheckRunningStatus = false) const;
diff -ruN vdr-1.3.24/i18n.c vdr-1.3.25/i18n.c
--- vdr-1.3.24/i18n.c	2005-05-05 15:12:54.000000000 +0200
+++ vdr-1.3.25/i18n.c	2005-05-15 16:37:59.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: i18n.c 1.188 2005/05/05 13:12:54 kls Exp $
+ * $Id: i18n.c 1.191 2005/05/15 14:37:59 kls Exp $
  *
  * Translations provided by:
  *
@@ -399,6 +399,27 @@
     "Kokkuvõte",
     "Omtale",
   },
+  { "Info",
+    "Info",
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+    "",//TODO
+  },
   { "Schedule - %s",
     "Programm - %s",
     "Program - %s",
@@ -3112,7 +3133,7 @@
     "",//TODO
     "ÈØàÞÚÞíÚàÐÝÝÞÕ Ø×ÞÑàÐÖÕÝØÕ",
     "",//TODO
-    "",//TODO
+    "Video kuvamise formaat",
     "Video display format",
   },
   { "pan&scan",
@@ -3343,7 +3364,7 @@
     "",//TODO
     "¿àÕÔßÞçØâÐÕÜëÕ ï×ëÚØ (×ÒãÚ)",
     "",//TODO
-    "",//TODO
+    "Audio keeled",
     "Audio sprog (ant.)",
   },
   { "Setup.DVB$Audio language",  // note the singular
@@ -3364,7 +3385,7 @@
     "",//TODO
     "²ëÑàÐÝ",
     "",//TODO
-    "",//TODO
+    "Audio keel",
     "Audio sprog",
   },
   { "Setup.LNB$SLOF (MHz)",
@@ -4039,7 +4060,7 @@
     "Fase 1: Detectant el tipus de receptor",
     "ÈÐÓ 1: ¾ßàÕÔÕÛÕÝØÕ âØßÐ ÚÞÔÐ ßãÛìâÐ",
     "Faza 1: detektiranje kôda daljinskog upravljaèa.",
-    "Aste 1: Koodeerimissüsteemi tuvastamine",
+    "Aste 1: Kodeerimissüsteemi tuvastamine",
     "Fase 1: Detekterer fjernbetjenings-kodetype",
   },
   { "Press any key on the RC unit",
@@ -4081,7 +4102,7 @@
     "Codi detectat!",
     "¾ÑÝÐàãÖÕÝ ÚÞÔ ßãÛìâÐ!",
     "Kôd daljinskog upravljaèa je prepoznat!",
-    "Koodeerimissüsteem tuvastatud!",
+    "Kodeerimissüsteem tuvastatud!",
     "Fjernbetjenings-kodetype fundet!",
   },
   { "Do not press any key...",
@@ -5049,7 +5070,7 @@
     " Aturar la reproducció",
     " ¿àÕÚàÐâØâì ÒÞáßàÞØ×ÒÕÔÕÝØÕ",
     " Prekini reprodukciju",
-    " Lõpeta kordus",
+    " Lõpeta taasesitamine",
     " Stop afspilning",
   },
   { " Stop recording ", // note the leading and trailing blanks!
@@ -5259,8 +5280,8 @@
     "",// TODO
     "",// TODO
     "",// TODO
-    "",// TODO
-    "",// TODO
+    "EPG skaneerimine käivitatud",
+    "Starter EPG skanning",
   },
   { "This plugin has no setup parameters!",
     "Dieses Plugin hat keine Setup-Parameter!",
diff -ruN vdr-1.3.24/libsi/Makefile vdr-1.3.25/libsi/Makefile
--- vdr-1.3.24/libsi/Makefile	2005-05-05 13:01:46.000000000 +0200
+++ vdr-1.3.25/libsi/Makefile	2005-05-29 13:47:12.000000000 +0200
@@ -1,12 +1,12 @@
 #
 # Makefile for a libsi
 #
-# $Id: Makefile 1.4 2005/05/05 11:01:46 kls Exp $
+# $Id: Makefile 1.5 2005/05/29 11:47:12 kls Exp $
 
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -O2 -g -Wall -Woverloaded-virtual
+CXXFLAGS ?= -fPIC -O2 -g -Wall -Woverloaded-virtual
 AR = ar
 ARFLAGS = ru
 RANLIB = ranlib
diff -ruN vdr-1.3.24/libsi/si.c vdr-1.3.25/libsi/si.c
--- vdr-1.3.24/libsi/si.c	2004-10-16 17:12:57.000000000 +0200
+++ vdr-1.3.25/libsi/si.c	2005-05-28 16:11:16.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.c 1.13 2004/10/16 15:12:57 kls Exp $
+ *   $Id: si.c 1.14 2005/05/28 14:11:16 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -114,9 +114,10 @@
 
 Descriptor *DescriptorLoop::getNext(Iterator &it, DescriptorTag tag, bool returnUnimplemetedDescriptor) {
    Descriptor *d=0;
-   if (isValid() && it.i<getLength()) {
+   int len;
+   if (isValid() && it.i<(len=getLength())) {
       const unsigned char *p=data.getData(it.i);
-      const unsigned char *end=p+getLength()-it.i;
+      const unsigned char *end=p+len-it.i;
       while (p < end) {
          if (Descriptor::getDescriptorTag(p) == tag) {
             d=createDescriptor(it.i, returnUnimplemetedDescriptor);
@@ -132,9 +133,10 @@
 
 Descriptor *DescriptorLoop::getNext(Iterator &it, DescriptorTag *tags, int arrayLength, bool returnUnimplementedDescriptor) {
    Descriptor *d=0;
-   if (isValid() && it.i<getLength()) {
+   int len;
+   if (isValid() && it.i<(len=getLength())) {
       const unsigned char *p=data.getData(it.i);
-      const unsigned char *end=p+getLength()-it.i;
+      const unsigned char *end=p+len-it.i;
       while (p < end) {
          for (int u=0; u<arrayLength;u++)
             if (Descriptor::getDescriptorTag(p) == tags[u]) {
@@ -211,15 +213,17 @@
 }
 
 char *String::getText() {
-   if (getLength() < 0 || getLength() >4095)
+   int len=getLength();
+   if (len < 0 || len > 4095)
       return strdup("text error"); // caller will delete it!
-   char *data=new char(getLength()+1);
-   decodeText(data, getLength()+1);
+   char *data=new char(len+1);
+   decodeText(data, len+1);
    return data;
 }
 
 char *String::getText(char *buffer, int size) {
-   if (getLength() < 0 || getLength() >= size) {
+   int len=getLength();
+   if (len < 0 || len >= size) {
       strncpy(buffer, "text error", size);
       buffer[size-1] = 0;
       return buffer;
@@ -230,7 +234,8 @@
 
 //taken from VDR, Copyright Klaus Schmidinger <kls@cadsoft.de>
 char *String::getText(char *buffer, char *shortVersion, int sizeBuffer, int sizeShortVersion) {
-   if (getLength() < 0 || getLength() >= sizeBuffer) {
+   int len=getLength();
+   if (len < 0 || len >= sizeBuffer) {
       strncpy(buffer, "text error", sizeBuffer);
       buffer[sizeBuffer-1] = 0;
       *shortVersion = 0;
@@ -254,7 +259,8 @@
    if (*from == 0x10)
       from += 3; // skips code table info
 
-   for (int i = 0; i < getLength(); i++) {
+   int len=getLength();
+   for (int i = 0; i < len; i++) {
       if (*from == 0)
          break;
       if (    ((' ' <= *from) && (*from <= '~'))
@@ -281,9 +287,8 @@
    if (*from == 0x10)
       from += 3; // skips code table info
 
-   for (int i = 0; i < getLength(); i++) {
-      if (*from == 0)
-         break;
+   int len=getLength();
+   for (int i = 0; i < len; i++) {
       if (    ((' ' <= *from) && (*from <= '~'))
            || (*from == '\n')
            || (0xA0 <= *from)
@@ -299,6 +304,8 @@
          IsShortName++;
       else if (*from == 0x87)
          IsShortName--;
+      else if (*from == 0)
+         break;
       from++;
       if (to - buffer >= sizeBuffer - 1 || toShort - shortVersion >= sizeShortVersion - 1)
          break;
diff -ruN vdr-1.3.24/libsi/util.c vdr-1.3.25/libsi/util.c
--- vdr-1.3.24/libsi/util.c	2004-10-16 11:58:41.000000000 +0200
+++ vdr-1.3.25/libsi/util.c	2005-05-28 16:15:29.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: util.c 1.4 2004/10/16 09:58:41 kls Exp $
+ *   $Id: util.c 1.5 2005/05/28 14:15:29 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -263,9 +263,10 @@
 u_int32_t CRC32::crc32 (const char *d, int len, u_int32_t crc)
 {
    register int i;
+   const unsigned char *u=(unsigned char*)d; // Saves '& 0xff'
 
    for (i=0; i<len; i++)
-      crc = (crc << 8) ^ crc_table[((crc >> 24) ^ *d++) & 0xff];
+      crc = (crc << 8) ^ crc_table[((crc >> 24) ^ *u++)];
 
    return crc;
 }
